﻿namespace LiteBlog.Common.Entities
{
    using LiteBlog.Common.Components;
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;

    public class Post
    {        
        public Post()
        {
            Comments = new List<Comment>();
            Documents = new List<Document>();
            Categories = new List<Category>();
            Contents = string.Empty;
        }

        public string FileID { get; set; }
        public DateTime Time { get; set; }
        public string FormattedTime { get; set; }
       
        [Required(ErrorMessage = "Please enter a title for the post")]
        [RegularExpression(@"[\w-\?!:,\. ]+", ErrorMessage = "No special characters allowed in the title")]
        public string Title { get; set; }
     
        public string Author { get; set; }
        
        public List<Comment> Comments { get; set; }
        public List<Document> Documents { get; set; }
        public List<Category> Categories { get; set; }

        public PostInfo AsPostInfo()
        {
            var postInfo = new PostInfo();
            postInfo.FileID = FileID;
            postInfo.Title = Title;
            postInfo.Categories = Categories;
            postInfo.Time = Time;
            postInfo.Author = Author;
            return postInfo;
        }

        public string Contents { get; set; }
        public string HighlightedContents { get; set; }

     }
}