﻿namespace LiteBlog.Common.Entities
{
    using LiteBlog.Common.Enums;
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;

    public class PostInfo
    {
        public string FileID { get; set; }

        [Required(ErrorMessage="Please enter a title")]
        public string Title { get; set; }

        public string Author { get; set; }
        public DateTime Time { get; set; }
        public string FormattedTime { get; set; }
        public List<Category> Categories { get; set; }
        public PostType Type { get; set; }

        public PostInfo()
        {
            Categories = new List<Category>();
        }

        // Temporary field being stored
        // Can remove later!
        private string _monthId = string.Empty;
        public string MonthId
        {
            get
            {
                if (string.IsNullOrEmpty(_monthId))
                    return ArchiveMonth.GetMonthId(Time);
                return _monthId;
            }
            set
            {
                _monthId = value;
            }
        }

        public int Month 
        { 
            get { return Time.Month; }
        }

        public int Year
        {
            get { return Time.Year; }
        }
        
        public int Views { get; set; }
    }
}