﻿
namespace LiteBlog.Components
{
    using System;
    using System.Collections.Generic;
    using System.Linq;

    using LiteBlog.Common;
    using LiteBlog.Common.Entities;
    using LiteBlog.Common.Enums;
    using LiteBlog.Components.Contracts;
    using LiteBlog.XmlLayer.Contracts;
    using LiteBlog.XmlLayer;
    using LiteBlog.Components.Enums;

  
    public class ArchiveComp : BaseComp<IArchiveData>, IArchiveComp
    {
        public ArchiveComp(IArchiveData data, ICacheComp cache) : base(data, cache) { }
        
        public List<ArchiveMonth> Get()
        {
            List<ArchiveMonth> months = _cache.Get<List<ArchiveMonth>>(CacheType.Archive);
            if (months == null)
            {
                months = _data.Get();
                _cache.Put(CacheType.Archive, months);
            }

            return months;
        }

        public ArchiveMonth Get(int month, int year)
        {
            return Get().SingleOrDefault(a => a.Month == month && a.Year == year);
        }

        internal void Increment(int month, int year)
        {
            var archiveMonth = new ArchiveMonth(month, year);
            _data.Increment(archiveMonth);
        }

        internal void Decrement(int month, int year)
        {
            var archiveMonth = new ArchiveMonth(month, year);
            _data.Decrement(archiveMonth);
        }

    }
}