﻿namespace LiteBlog.Components
{
    using System;
    using System.Configuration;
    using System.Web;
    using LiteBlog.Common;
    using System.Web.Configuration;
    using LiteBlog.Common.Enums;
    using LiteBlog.XmlLayer;
    using LiteBlog.XmlLayer.Contracts;
    using LiteBlog.Components.Contracts;
    using LiteBlog.Components.Enums;
    using System.IO;

    public class ConfigComp : IConfigComp
    {
        private string dataPath = string.Empty;

        // Date format for storing values in the Db and retrieving data from there
        public static string DateFormat
        {
            get
            {
                return ConfigurationManager.AppSettings["DateFormat"];
            }
        }

        public static string DefaultPassword
        {
            get
            {
                return ConfigurationManager.AppSettings["DefaultPassword"];
            }
        }

        public string DataPath
        {
            get
            {
                return DataContext.DataPath;
            }
            set
            {
                DataContext.DataPath = value;
            }
        }

        public string DocumentVirtualPath
        {
            get
            {
                return VirtualPathUtility.ToAbsolute("~/Docs");
            }
        }

        public string DocumentPath
        {
            get
            {
                var rootPath = HttpContext.Current.Server.MapPath("~");
                var docPath = Path.Combine(rootPath, "Docs");
                if (!Directory.Exists(docPath))
                        Directory.CreateDirectory(docPath);
                return docPath;
            }
        }
    }
}