﻿namespace LiteBlog.Components.Helpers
{
    using System.Web.Caching;

    using LiteBlog.Common;
    using LiteBlog.Common.Enums;
    using LiteBlog.XmlLayer.Contracts;
    using LiteBlog.Components.Enums;
    using LiteBlog.XmlLayer;

    internal class CacheContext : ICacheContext
    {
        public CacheDependency GetDependency(CacheType type)
        {
            return this.GetDependency(type, string.Empty);
        }

        public CacheDependency GetDependency(CacheType type, string id)
        {
            switch (type)
            {
                case CacheType.Archive:
                    return new CacheDependency(ArchiveData.Path);
                case CacheType.Blog:
                    return new CacheDependency(BlogData.Path);
                case CacheType.Categories:
                    return new CacheDependency(CategoryData.Path);
                case CacheType.Settings:
                    return new CacheDependency(SettingsData.Path);
                case CacheType.Pages:
                    return new CacheDependency(PageData.Path);
                case CacheType.Post:
                    return new CacheDependency(PostData.GetCachePath(id));
                case CacheType.Comments:
                    return new CacheDependency(CommentData.Path);
                default:
                    return null;
            }
        }
    }
}