﻿using LiteBlog.Common.Components;
using LiteBlog.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace LiteBlog.Controllers.Filters
{
    public class AjaxExceptionFilter : FilterAttribute, IExceptionFilter
    {
        public void OnException(ExceptionContext filterContext)
        {
            if (filterContext.ExceptionHandled)
                return;

            var resultModel = new ResultModel { Result = false };
            if (filterContext.Exception != null)
            {
                Logger.Log("AjaxHandleErrorAttribute", filterContext.Exception);
                resultModel.Message = filterContext.Exception.Message;
            }
            var controller = filterContext.Controller as BaseController;
            filterContext.Result = controller.GetJsonResult(resultModel);
            filterContext.ExceptionHandled = true;
        }
    }
}