﻿using LiteBlog.Common;
using LiteBlog.Common.Entities;
using LiteBlog.Components;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace LiteBlog.Controllers.Filters
{
    public class CrawlerFilterForPosts : ActionFilterAttribute 
    {
        public override void OnActionExecuted(ActionExecutedContext filterContext)
        {
            var controller = filterContext.Controller as BaseController;
            if (controller.Request.Browser.Crawler)
            {
                // If you are a crawler, I got you a special page!
                var posts = filterContext.RouteData.Values["posts"] as List<Post>;
                var viewName = "Crawler" + filterContext.ActionDescriptor.ActionName;
                filterContext.Result = controller.GetViewResult(viewName, posts);
            }
            else
            {
                // If you are not a crawler, go to the cool page that we got.
                base.OnActionExecuted(filterContext);
            }
        }
    }
}