﻿using LiteBlog.Components.Contracts;
using LiteBlog.Controllers.Contracts;
using LiteBlog.Controllers.Filters;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;

namespace LiteBlog.Controllers
{
    public class ScheduleController : BaseController, IScheduleController
    {
        public ScheduleController(ISettingsComp settingsComp, IBlogComp blogComp, IBackupComp backupComp)
            : base(settingsComp)
        {
            BlogComponent = blogComp;
            BackupComponent = backupComp;
        }

        public IBlogComp BlogComponent { get; set; }
        public IBackupComp BackupComponent { get; set; }

        [Authorize]
        [PageExceptionFilter]
        public ActionResult Publish()
        {
            BlogComponent.PublishScheduled();
            return new EmptyResult();
        }

        [PageExceptionFilter]
        public ActionResult Backup()
        {
            var settings = _settingsComponent.Load();
            if (settings.ShouldBackup)
                BackupComponent.Backup();
            return new EmptyResult();
        }
    }
}
