﻿using Castle.DynamicProxy;
using LiteBlog.Common.Components;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LiteBlog.IoC
{
    class MethodInterceptor : IInterceptor 
    {
        public void Intercept(IInvocation invocation)
        {
            var resolves = invocation.MethodInvocationTarget.GetCustomAttributes(typeof(ResolveAttribute), true);
            var target = invocation.InvocationTarget;
            if (resolves != null && resolves.Length > 0)
            {
                foreach (var resolve in resolves)
                {
                    var propertyName = (resolve as ResolveAttribute).PropertyName;
                    var propertyInfo = target.GetType().GetProperty(propertyName);
                    var resolvedObject = IoCContainer.Resolve(propertyInfo.PropertyType);
                    propertyInfo.SetValue(target, resolvedObject, null);
                }
            }

            invocation.Proceed();
        }
    }
}
