﻿using Castle.DynamicProxy;
using StructureMap;
using StructureMap.Interceptors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LiteBlog.IoC
{
    class ObjectInterceptor : InstanceInterceptor
    {
        private ProxyGenerator generator = new ProxyGenerator();
        private MethodInterceptor interceptor = new MethodInterceptor();

        // Intercept interface only
        // Intercept virtual method of classes
        public object Process(object target, IContext context)
        {
            var interfaceType = context.BuildStack.Current.RequestedType;
            return generator.CreateInterfaceProxyWithTarget(interfaceType, target, interceptor);
        }
    }
}
