﻿using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;

namespace LiteBlog.Models
{
    public class ChangePasswordModel : LoginModel
    {
        public ChangePasswordModel()
        {
            NewPassword = RepeatPassword = string.Empty;
        }

        [Required(ErrorMessage = "Please enter a new password")]
        public string NewPassword { get; set; }

        [Required(ErrorMessage = "Please enter the new password again")]
        [Compare("NewPassword", ErrorMessage="The password entered should match the new password")]
        public string RepeatPassword { get; set; }
    }
}