﻿namespace LiteBlog.XmlLayer
{
    using LiteBlog.Common;
    using LiteBlog.XmlLayer.Contracts;
    using System.Configuration;
    using System.Web;
    using System.Web.Configuration;

    public class DataContext
    {
        internal static string DateTimeFormat = "dd-MMM-yyyy hh:mm tt";

        private static string dataPath = string.Empty;
        public static string DataPath
        {
            get
            {
                if (!string.IsNullOrEmpty(dataPath))
                    return dataPath;

                dataPath = ConfigurationManager.AppSettings["DataPath"];
                if (string.IsNullOrEmpty(dataPath) || !System.IO.Directory.Exists(dataPath))
                {
                    if (HttpContext.Current != null)
                    {
                        dataPath = HttpContext.Current.Server.MapPath("~/App_Data/");
                    }
                }

                return dataPath;
            }

            set
            {
                Configuration config = WebConfigurationManager.OpenWebConfiguration("~");
                config.AppSettings.Settings["DataPath"].Value = value.ToString();
                config.Save();
            }
        }
    }
}