﻿namespace LiteBlog.XmlLayer.Helpers
{
    using System;
    using System.Linq;
    using System.Xml;
    using System.Xml.Linq;

    using LiteBlog.Common;
    using LiteBlog.Common.Components;
    using System.Text;

    class XmlHelper
    {
        internal static void Save(XElement root, string path)
        {
            XmlWriterSettings settings = new XmlWriterSettings();
            settings.Indent = true;
            XmlWriter writer = XmlWriter.Create(path, settings);
            root.Save(writer);
            writer.Close();
        }

        internal static string GetInnerXml(XElement elem)
        {
            StringBuilder innerXml = new StringBuilder();
            elem.Nodes().ToList().ForEach(node => innerXml.Append(node.ToString()));
            return innerXml.ToString();
        }
    }
}