﻿function Authors() {
    this.collection = ko.observableArray();
    this.successMessage = ko.observable();
    this.errors = ko.observableArray();
    this.admin = ko.observable(admin);

    // generic
    this.errorMessage = ko.computed({
        read: function () {
            var html = '';
            if (this.errors().length > 0)
                html += this.errors()[0];
            if (this.errors().length > 1) {
                html += "<ul>"
                for (var idx = 1; idx < this.errors().length; idx++)
                    html += "<li>" + this.errors()[idx] + "</li>";
                html += "</ul>";
            }
            return html;
        },
        write: function (value) {
            this.errors.removeAll();
            this.errors.push(value);
        },
        owner: this
    });

    this.addEnable = ko.observable(true);

    // non-generic: item creation
    this.loadJson = function (data) {
        for (var idx = 0; idx < data.length; idx++) {
            var elem = data[idx];
            var item = new Author(this);
            item.isOdd(idx % 2 == 0);
            item.load(elem);
            this.collection.push(item);
        }
    }

    // generic
    this.redoOdd = function () {
        for (var idx = 0; idx < this.collection().length; idx++) {
            var item = this.collection()[idx];
            item.isOdd(idx % 2 == 0);
        }
    }

    // non-generic: item creation
    this.add = function () {
        var item = new Author(this);
        item.isEdit(true);
        item.isNew(true);
        this.collection.push(item);
        this.addEnable(false);
    }

    this.get = function(id) {
        for(var idx=0; idx<this.collection().length; idx++) {
            if(this.collection()[idx].name()==id)
                return this.collection()[idx];
        }
    }

    this.makePrimary = function (id) {
        for (var idx = 0; idx < this.collection().length; idx++) {
            if (this.collection()[idx].primary()) {
                this.collection()[idx].primary(false);
                break;
            }
        }
        var newPrimary = this.get(id);
        newPrimary.primary(true);
    }

    // non-generic: property to match
    this.remove = function (removeItem) {
        this.collection.remove(function (item) { return item.name() == removeItem.name() });
    }
}