﻿function Pages() {
    var self = this;
    this.collection = ko.observableArray();

    this.successMessage = ko.observable();
    this.errors = ko.observableArray();
    this.errorMessage = ko.computed({
        read: function () {
            var html = '';
            if (this.errors().length > 0)
                html += this.errors()[0];
            if (this.errors().length > 1) {
                html += "<ul>"
                for (var idx = 1; idx < this.errors().length; idx++)
                    html += "<li>" + this.errors()[idx] + "</li>";
                html += "</ul>";
            }
            return html;
        },
        write: function (value) {
            this.errors.removeAll();
            this.errors.push(value);
        },
        owner: this
    });

    this.addEnable = ko.observable(true);

    this.loadJson = function (data) {
        for (var idx = 0; idx < data.length; idx++) {
            var elem = data[idx];
            var item = new Page(this);
            item.isOdd(idx % 2 == 0);
            item.load(elem);
            this.collection.push(item);
        }
    }

    this.redoOdd = function () {
        for (var idx = 0; idx < this.collection().length; idx++) {
            var item = this.collection()[idx];
            item.isOdd(idx % 2 == 0);
        }
    }

    this.add = function () {
        window.location = appPath + 'Page/Compose';
    }

    this.get = function (id) {
        for (var idx = 0; idx < this.collection().length; idx++) {
            if (this.collection()[idx].id() == id)
                return this.collection()[idx];
        }
    }

    this.remove = function (removeItem) {
        this.collection.remove(function (item) { return item.id() == removeItem.id() });
    }
}