﻿function CommentVm(p) {
    var self = this;
    this.post = p;
    this.id = ko.observable();
    this.fileId = ko.observable();
    this.name = ko.observable('');
    this.comment = ko.observable('');
    this.url = ko.observable('');
    this.time = ko.observable();
    this.isAuthor = ko.observable(false);
    this.className = ko.computed(function () {
        if (this.isAuthor())
            return 'authorBg';
        else
            return '';
    }, this);
    this.isApproved = ko.observable();

    this.errors = ko.observableArray();
    this.errorMessage = ko.computed({
        read: function () {
            var html = '';
            if (this.errors().length > 0)
                html += this.errors()[0];
            if (this.errors().length > 1) {
                html += "<ul>"
                for (var idx = 1; idx < this.errors().length; idx++)
                    html += "<li>" + this.errors()[idx] + "</li>";
                html += "</ul>";
            }
            return html;
        },
        write: function (value) {
            this.errors.removeAll();
            this.errors.push(value);
        },
        owner: this
    });

    this.addComment = function () {

        var postVm = p;
        // call the web api
        var path = appPath + 'Comment/Create';
        var self = this;
        var input = {
            FileID: self.fileId(),
            Name: self.name(),
            RawComment: self.comment(),
            Url: self.url()
        };
        
        $.post(path, input, function (data) {
            if (!data.Result) {
                self.errorMessage(data.Message);
                if (data.Errors) {
                    for (var idx = 0; idx < data.Errors.length; idx++)
                        self.errors.push(data.Errors[idx]);
                }
            }
            else {
                postVm.insertCommentMessage(data.Message);
                setTimeout(function () { postVm.insertCommentMessage(''); }, 3000);
                
                var comment = data.Data;
                var commentVm = new CommentVm(postVm);
                commentVm.id(comment.ID);
                commentVm.fileId(comment.FileID);
                commentVm.name(comment.Name);
                commentVm.comment(comment.Text);
                commentVm.time(comment.FormattedTime);
                commentVm.url(comment.Url);
                commentVm.isAuthor(comment.IsAuthor);
                commentVm.isApproved(comment.IsApproved);
                if (commentVm.isApproved()) {
                    postVm.comments.unshift(commentVm);
                    postVm.commentCount(postVm.commentCount() + 1);
                }
                postVm.showForm(false);
            }
        });
    };

    this.closeComment = function () {
        var postVm = p;
        postVm.showForm(false);
    }
}